<template>
  <div class="Setting-container">
    <div class="Setting-info">
      <div class="Setting-item-title">我</div>
      <div class="Setting-item-detailsInformation">
        <div style="width:20px;"></div>
        <div
          class="Setting-item-avater"
          :style="{backgroundImage: 'url(' +avatar+ ')',backgroundRepeat:'no-repeat', backgroundPosition:'center center', backgroundSize: 'contain'}"
        ></div>

        <div class="Setting-item-personInformation">
          <div style="font-weight:bold;font-size:17px;letter-spacing:0.113rem;margin-bottom:3px;">{{nickName}}</div>
          <div class="mes" style="margin-top:0px;font-size:13px;">
            <span class="gender-info">{{myGender}}</span>
            <span class="education-info">{{grade}}</span>
            <span class="education-info">{{college}}</span>
            <span class="education-info">{{major}}</span>
          </div>
          <div style="font-size:11px;letter-spacing:0.113rem;margin-top:5px;">{{description}}</div>
        </div>

        <div
          style="color:#a1a1a1;margin-right:7.6%;font-size:9px;letter-spacing:0.113rem;"
          @click="toTheSetting()"
        >
          更多
          <img :src="right" alt style="height:8.45px;wideth:10.7px;" />
        </div>
      </div>

      <router-link class="Setting-item-details-follower" to="/followList">
        <span class="digit">{{follower}}</span>
        <span class="description" style="margin-right:30px;">关注我的人</span>
        <span class="digit">{{star}}</span>
        <span class="description">我关注的人</span>
        <span style="font-size:16px;color:#666464;margin-top:10px;margin-bottom:10px;"></span>
      </router-link>
      <div class="Setting-item-details">
        <div class="tag-container" @click="isShow.isShowTagChoser=true">
          <div class="tag" v-for="(tag,i) in tags" :key="i">{{tag.name}}</div>
          <div class="hint" v-if="tags.length==0">点我设置标签~</div>
        </div>
        <van-popup
          v-model="isShow.isShowTagChoser"
          round
          position="bottom"
          :style="{ height: '70%' }"
        >
          <TagChoser :chosenTagsProps="this.tags" />
        </van-popup>
      </div>
    </div>
    <div class="Setting-item-btns">
      <div class="Setting-item-settings">
        <div class="Setting-item-settings-title" @click="jumpToFavorite()">
          <i class="icon-font-v1 icon-font-zhengli"></i>
          我收藏的图版
          <div style="flex:1">
            <img
                :src="back"
            />
          </div>
        </div>
        <div class="clear"></div>
        <div class="Setting-item-settings-title" @click="jumpToParticipate()">
          <i class="icon-font-v1 icon-font-wenjuan"></i>
          我参加的图版
          <div style="flex:1">
            <img
                :src="back"
            />
          </div>
        </div>
        <div class="clear"></div>
        <div class="Setting-item-settings-title" @click="jumpToSponsorial()">
          <i class="icon-font-v1 icon-font-tianjiayouhuiquan"></i>
          我发起的图版
          <div style="flex:1">
            <img
                :src="back"
            />
          </div>
        </div>
        <div class="clear"></div>
      </div>
      <div class="Setting-item-theSetting" @click="toTheSetting()">
        <i class="icon-font-v1 icon-font-shezhi"></i>
          设置
          <div style="flex:1">
            <img
                :src="back"
            />
          </div>
      </div>
      <div class="Setting-item-exit" @click="exit()">
        <i class="icon-font-v1 icon-font-tuichu red"></i>
          退出登录
          <div style="flex:1">
          </div>
      </div>
    </div>
  </div>
</template>

<script>
import { Toast } from "vant";
import rightright from "@/assets/right.png";
import goback from "@/assets/goback.png";
import TagChoser from "@/components/setting/TagChoser";
export default {
  name: "Setting",
  data() {
    return {
      avatar: "",
      nickName: "正在加载中",
      gender: "",
      grade: "",
      back: goback,
      college: "",
      major: "",
      description: "",
      star: 0,
      myGender: "",
      follower: 0,
      tags: [],
      right: rightright,
      aletMsg: "", // 弹出框中的提示语
      displayStsates: "none",
      tagsInputVisible: true,
      isShow: {
        isShowTagChoser: false
      }
    };
  },
  methods: {
    judgeAvatar(avatar) {
      if (avatar == "") {
        return false;
      } else return true;
    },
    exit() {
      this.$api
        .logout()
        .then(() => {
          Toast("已登出");
          this.$router.push("/first");
        })
        .catch(() => {
          console.log("11111111111111");
        });
    },
    alertDia2(msg) {
      this.displayStsates = "block";
      this.aletMsg = msg;
      // 延迟2秒后消失 自己可以更改时间
      window.setTimeout(() => {
        this.displayStsates = "none";
        this.$router.push("/first");
      }, 2000);
    },
    toTheSetting() {
      this.$router.push("/personInfo_toItself");
    },
    jumpToFavorite() {
      this.$router.push("/favoriteBoards");
    },
    jumpToParticipate() {
      this.$router.push("/participateBoards");
    },
    jumpToSponsorial() {
      this.$router.push("/sponsorialBoards");
    },
    tip() {
      if (this.nickName == null) {
        this.nickName = "请登记个人信息";
      }
    },
    sortByID() {
      this.tags.sort(function(a, b) {
        return a.id - b.id;
      });
    },
    saveTags() {
      this.tagsInputVisible = true;
    },
    deleteTag(id) {
      this.$api.deleteMyTagById(id).then(res => {
        console.log(res);
      });
      this.$api.getMyTags().then(res => {
        this.tags = res.data.data;
        this.sortByID();
      });
    },
    addTag(id) {
      this.$api.addMyTagById(id).then(res => {});
      this.$api.getMyTags().then(res => {
        this.tags = res.data.data;
        this.sortByID();
      });
    },
    judge(item) {
      for (let items of this.tags) {
        if (item.name == items.name) {
          return true;
        }
      }
      return false;
    }
  },
  mounted: async function() {
    this.$api
      .myInfo()
      .then(res => {
        this.avatar = res.data.data.profilePhotoUrl;
        console.log(this.avatar[1]);
        //this.avatar='http://simplebits.com/img/glass-btn.png';
        console.log(res.data.data.profilePhotoUrl);
        this.nickName = res.data.data.name;
        this.gender = res.data.data.sexual;
        if (this.gender == 0) {
          this.myGender = "女";
        }
        if (this.gender == 1) {
          this.myGender = "男";
        }
        this.college = res.data.data.college;
        this.major = res.data.data.major;
        this.description = res.data.data.introduction;
        this.$api.myFollow().then(res => {
          this.follower = res.data.data.followers;
          this.star = res.data.data.followings;
        });

        this.$api.getMyTags().then(res => {
          this.tags = res.data.data;
          console.log(this.tags);
          this.sortByID();
        });
        this.tip();
      })
      .catch(() => {});
  },
  components: {
    TagChoser
  }
};
</script>

<style scoped lang="less">
.Setting-container {
  width: 100%;
  height: calc(100vh - var(--tab-bar-height));
  overflow-x: hidden;
  .Setting-info {
    margin: 0px;
    border-radius: 10px;
    padding: 0 3% 0 3%;
  }
  .Setting-item-title {
    position: fixed;
    top: 0;
    left: 0;
    width: 100%;
    font-size: 16px;
    font-weight: bold;
    color: #8c8c8c;
    text-align: center;
    line-height: 46.5px;
    height: 46.5px;
    background-color: white;
  }
  .Setting-item-details-follower {
    padding: 0 6.3% 0 6.3%;
    background: white;
    display: flex;
    flex-direction: row;
    align-items: center;
    height: 54px;
    .digit {
      color: #3170ff;
      font-size: 24px;
      margin-right: 12px;
      font-weight: bold;
    }
    .description {
      font-size: 14px;
      color: #666464;
      margin-top: 17px;
      margin-bottom: 10px;
      font-weight: bold;
      letter-spacing: 0.113rem;
    }
  }

  .Setting-item-details-myTag {
    margin: 0px 3.6% 1px 3.2%;
    background: white;
    display: flex;
    flex-direction: row;
    align-items: center;
    height: 75px;
    .Setting-item-tags {
      display: flex;
      flex-wrap: wrap;
      width: 100%;
      margin-left: 5.29%;
      padding-top: 20px;
      height: 76px;
      padding-bottom: 10px;
      .Setting-item-tags-tag {
        height: 32px;
        width: 43px;
        font-size: 14px;
        //font-weight:bold;
        border: 2px solid #3170ff;
        color: #666464;
        margin: 2px 10px 2px 4px;
        line-height: 32px;
        border-radius: 5px;
      }
      .Setting-item-tags-choosenTag {
        height: 32px;
        width: 43px;
        font-size: 14px;
        //font-weight:bold;
        color: white;
        border: 2px solid #3170ff;
        margin: 2px 10px 2px 4px;
        background-color: #3170ff;
        line-height: 32px;
        border-radius: 5px;
      }
      .Setting-item-tags-button {
        font-size: 14px;
        height: 32px;
        width: 33px;
        //font-weight:bold;
        color: white;
        background-color: #3170ff;
        margin: 3px 2.8% 2px 4px;
        line-height: 32px;
        border-radius: 5px;
      }
      .Setting-item-tags-savebutton {
        font-size: 14px;
        height: 32px;
        width: 43px;
        //font-weight:bold;
        color: white;
        text-align: center;
        background-color: #3170ff;
        margin: 3px 2.8% 2px 4px;
        line-height: 32px;
        border-radius: 5px;
      }
    }
  }
  .Setting-item-detailsInformation {
    margin: 57.5px 0 1px 0;
    background: white;
    height: 116px;
    display: flex;
    flex-direction: row;
    align-items: center;
    border-radius: 10px 10px 0px 0px;
    .Setting-item-avater {
      width: 60.5px;
      height: 60.5px;
      border-radius: 100%;
      border: #626262 1px solid;
      background: #bfbfbf;
      border-style: solid;
      border-color: gray;
      border-width: 1px;
    }
    .Setting-item-avater img {
      width: 60.5px;
      height: 60.5px;
      border-radius: 100%;
      border-style: solid;
      border-color: gray;
      border-width: 1px;
    }
    .Setting-item-personInformation {
      margin: 0 2px 0 18px;
      flex: 1;
    }
    .mes .gender-info {
      margin-right: 7px;
      letter-spacing: 0.13rem;
      font-size: 11px;
      letter-spacing: 0.37px;
      color: #7c7c7c;
    }
    .mes .education-info {
      margin-right: 5px;
      font-size: 11px;
      letter-spacing: 0.113rem;
      color: #7c7c7c;
    }
  }
  .clear {
    clear: both;
  }
}
.Setting-item-btns {
  margin-top: 12px;
  .Setting-item-settings {
    display: flex;
    flex-direction: column;
    }
    .Setting-item-settings-title,
    .Setting-item-theSetting,
    .Setting-item-exit{
        display: flex;
        align-items: center;
        font-size: 13px;
        font-weight: 600;
        height: 43px;
        padding-left: 8.76%;
        margin-bottom: 1px;
        //word-spacing: 350px;
        background: white;
        margin-top: 33% solid #ffffff;
        letter-spacing: 0.113rem;
        i{
            color: #666;
            margin-right: 11px;
        }
        img{
            transform: rotate(180deg);
            width:6px;
            height:10px;
            margin-right:20px;
            float: right;
        }
  }
  .Setting-item-theSetting {
    height: 43px;
    line-height: 43px;
    font-size: 13px;
    letter-spacing: 0.113rem;
    font-weight: bold;
    padding-left: 8.76%;
    margin-top: 12px;
    margin-bottom: 12px;
    background: #ffffff;
    word-spacing: 430px;
  }
  .Setting-item-exit {
    height: 43px;
    line-height: 43px;
    font-weight: bold;
    letter-spacing: 0.113rem;
    padding-left: 8.76%;
    font-size: 13px;
    background: #ffffff;
    word-spacing: 430px;
    color: #c61515;
    .red{
        color: #c61515;
    }
  }
}
.Setting-item-details {
  .tag-container {
    margin: 1px 0 1px 0;
    padding: 20px 24px 20px 19px;
    background-color: white;
    border-radius: 0px 0px 10px 10px;
    padding: 13px 6% 3px 6%;

    display: flex;
    flex-direction: row;
    flex-wrap: wrap;
    align-content: flex-start;
    justify-content: flex-start;
    .tag {
      color: #666464;
      font-size: 12px;
      font-weight: bold;
      letter-spacing: 0.05em;
      display: inline-block;
      height: 28px;
      line-height: 28px;
      padding: 0 10px 0 10px;
      border: 1.5px #3170ff solid;
      border-radius: 8px;
      margin-right: 10px;
      margin-bottom: 10px;
    }
    .hint {
      flex: 1;
      font-size: 12px;
      color: #aaa;
      margin-bottom: 10px;
      text-align: center;
    }
  }
}
</style>
